<?php

namespace App\Http\Controllers;

use App\Models\Batiment;
use App\Models\InfraBatiment;
use App\Models\Infrastructure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use RealRashid\SweetAlert\Facades\Alert;

class InfraBatimentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $batiment = Batiment::all();
        $infrastructure =Infrastructure::all();
        return view('Admin.pages.File_infra_batiments.Infra_batiments' , compact('batiment','infrastructure'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $donnees = DB::table('infra_batiments')
        ->join('batiments', 'infra_batiments.batiment_id', '=', 'batiments.id')
        ->join('infrastructures', 'infra_batiments.infrastructure_id', '=', 'infrastructures.id')
        ->select(
            'infra_batiments.id',
            'batiments.nomBatiment',
            'infrastructures.nomInfra',
            'infrastructures.latitudeInfra',
            'infrastructures.longitudeInfra'
        )
        ->get();


        // Remplacez "VotreModele" par le nom de votre modèle de données

    return response()->json($donnees);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = array(
            'batiment_id' => 'required',
            'infrastructure_id' => 'required',

        );

        $error = Validator::make($request->all(), $rules);

        if ($error->fails()) {
            Alert::toast('Add success','success');

            return redirect()->back()->withErrors($error)->withInput();
        }

        try {
            $form_data = array(
                'batiment_id' => $request->batiment_id,
                'infrastructure_id' => $request->infrastructure_id,
            );


            InfraBatiment::create($form_data);
            Alert::toast('Add success','success');
            return redirect()->back()->withInput();
        } catch (\Illuminate\Database\QueryException $exception) {
        Alert::toast('Une erreur s\'est produite lors de l\'ajout','error' /*. $exception->getMessage()*/);
            return redirect()->back()->withInput();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request)
    {


    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
      public function edit($id)
    {
        $InfrastructureBat = InfraBatiment::find($id);
        return response()->json([
            'status' => 200,
            'InfrastructureBat' => $InfrastructureBat,
        ]);
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
        //la route update a été détacher de la route ressource  (faite un php artisan route:list)
        $infrastructureBat_id = $request->input('id');
        $infrastructureBat= InfraBatiment::find($infrastructureBat_id);
        try {
            $infrastructureBat->batiment_id = $request->input('batiment_id');
            $infrastructureBat->infrastructure_id = $request->input('infrastructure_id');
            $infrastructureBat->update();
            Alert::toast('Update success','success');
            return redirect()->route('Infra+Batiment.index');
        } catch (\Illuminate\Database\QueryException $exception) {
            Alert::toast('Veuillez rempli tous champs','error');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {

        $data_id = $request->input('deleteInfraBatiment');
        $data = InfraBatiment::find($data_id);

        try {
            $data->delete();
            Alert::toast('Delete success','success');
        } catch (\Illuminate\Database\QueryException $exception) {
            $errorInfo = $exception->errorInfo;

            if ($errorInfo[0] === '23000' && $errorInfo[1] === 1451) {
                $affectedTables = $this->getAffectedTables($errorInfo[2]);
                $errorMessage = "Impossible de supprimer l'événement. Il est référencé dans les tableaux suivants : " . implode(", ", $affectedTables);
                Alert::toast($errorMessage,'error');
            } else {
                Alert::toast($exception->getMessage(),'error');
            }
        }

        return  redirect()->back()->withInput();
    }

    private function getAffectedTables($errorMessage)
    {
        preg_match_all("/`(.+?)`/", $errorMessage, $matches);
        return $matches[1];
    }
}
